#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

char a[105][105], b[105][105];

int n, m;
string fake;

bool good(int i, int j) {
	if (i < 0 || i >= n || j < 0 || j >= m) {
		return false;
	}
	return true;
}

bool isnear(char a[][105], int i, int j) {
	
	for (int q = -1; q <= 1; q++) {
		if (good(i + q, j) && a[i + q][j] == '*') {
			return true;
		}
		if (good(i, j + q) && a[i][j + q] == '*') {
			return true;
		}
	}
	return false;
	
}

void go(char a[][105], char b[][105]) {
	
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (isnear(a, i, j)) {
				b[i][j] = '*';
			}
		}
	}
	
}

bool isfull(char a[][105]) {
	
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (a[i][j] == '.') {
				return false;
			}
		}
	}
	return true;
	
}

void arrout(char a[][105]) {
	
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << a[i][j];
		}
		cout << endl;
	}
	
}

int main() {

	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
			b[i][j] = '.';
		}
		getline(cin, fake);
	}
	if (isfull(a)) {
		cout << "0" << endl;
		return 0;
	}
	int steps = 0;
	while (true) {
		steps++;
		if (steps % 2) {
			go(a, b);
			if (isfull(b)) {
				cout << steps << endl;
				return 0;
			}
		} else {
			go(b, a);
			if (isfull(a)) {
				cout << steps << endl;
				return 0;
			}
		}
	}

	return 0;

}
